<template lang="pug">
transition(@enter="onEnter" @leave="onLeave" :css="false" :appear="appear")
  slot
</template>

<script>
import _ from 'lodash'
import Anim from './BaseAnimation'

/*
 * CSS animations are easier to achieve in an inline-block that has no
 * margins/padding, which is what this components does
 */
export default {
  name: 'BaseAnimationBlock',
  props: {
    appear: { type: Boolean, default: true },
    animIn: { type: String, default: 'defaultIn' },
    animOut: { type: String, default: 'defaultOut' },
    options: { type: Object }
  },
  methods: {
    onEnter(elt, done) {
      _.invoke(Anim, this.animIn, elt, this.options, done);
    },
    onLeave(elt, done) {
      _.invoke(Anim, this.animOut, elt, this.options, done);
    }
  }
}
</script>

<style>
div.transition-block {
  display: inline-block;
}
</style>
